module SameSiteCookieFix
  class Helpers

    SHOPIFY_APP_VERSION_WITH_SAMESITE_FIX = '11.6.0'.freeze

    def self.should_load_railtie?
      rails_is_defined? && !(shopify_app_is_defined? && shopify_app_has_samesite_fix?)
    end

    def self.rails_is_defined?
      defined?(Rails)
    end

    def self.shopify_app_is_defined?
      defined?(ShopifyApp)
    end

    def self.shopify_app_has_samesite_fix?
      Gem::Version.new(ShopifyApp::VERSION) >= Gem::Version.new(SHOPIFY_APP_VERSION_WITH_SAMESITE_FIX)
    end

  end
end
